Index: cpukit/Makefile.am
===================================================================
--- cpukit/Makefile.am	(revision 71689a0775f39d65b3c9f0a81b58394d0b04e534)
+++ cpukit/Makefile.am	(revision f2185d109930fb5db31a5c228a3f46178072f270)
@@ -177,4 +177,5 @@
 librtemscpu_a_SOURCES += libcsupport/src/mallocfreespace.c
 librtemscpu_a_SOURCES += libcsupport/src/mallocgetheapptr.c
+librtemscpu_a_SOURCES += libcsupport/src/mallocheap.c
 librtemscpu_a_SOURCES += libcsupport/src/mallocinfo.c
 librtemscpu_a_SOURCES += libcsupport/src/malloc_initialize.c
@@ -1026,4 +1027,6 @@
 librtemscpu_a_SOURCES += score/src/wkspace.c
 librtemscpu_a_SOURCES += score/src/wkspaceisunifieddefault.c
+librtemscpu_a_SOURCES += score/src/wkspacemallocinitdefault.c
+librtemscpu_a_SOURCES += score/src/wkspacemallocinitunified.c
 librtemscpu_a_SOURCES += score/src/wkstringduplicate.c
 librtemscpu_a_SOURCES += score/src/iobase64.c
Index: cpukit/include/rtems/confdefs/wkspace.h
===================================================================
--- cpukit/include/rtems/confdefs/wkspace.h	(revision 71689a0775f39d65b3c9f0a81b58394d0b04e534)
+++ cpukit/include/rtems/confdefs/wkspace.h	(revision f2185d109930fb5db31a5c228a3f46178072f270)
@@ -127,4 +127,7 @@
 #ifdef CONFIGURE_UNIFIED_WORK_AREAS
   const bool _Workspace_Is_unified = true;
+
+  struct Heap_Control *( * const _Workspace_Malloc_initializer )( void ) =
+    _Workspace_Malloc_initialize_unified;
 #endif
 
Index: cpukit/include/rtems/malloc.h
===================================================================
--- cpukit/include/rtems/malloc.h	(revision 71689a0775f39d65b3c9f0a81b58394d0b04e534)
+++ cpukit/include/rtems/malloc.h	(revision f2185d109930fb5db31a5c228a3f46178072f270)
@@ -44,5 +44,5 @@
 extern Heap_Control *RTEMS_Malloc_Heap;
 
-void RTEMS_Malloc_Initialize(
+Heap_Control *RTEMS_Malloc_Initialize(
   const Memory_Information              *mem,
   Heap_Initialization_or_extend_handler  extend
Index: cpukit/include/rtems/score/wkspacedata.h
===================================================================
--- cpukit/include/rtems/score/wkspacedata.h	(revision 71689a0775f39d65b3c9f0a81b58394d0b04e534)
+++ cpukit/include/rtems/score/wkspacedata.h	(revision f2185d109930fb5db31a5c228a3f46178072f270)
@@ -44,4 +44,6 @@
 #endif
 
+struct Heap_Control;
+
 /**
  * @addtogroup RTEMSScoreWorkspace
@@ -66,4 +68,28 @@
 extern const bool _Workspace_Is_unified;
 
+/**
+ * @brief Initializes the C Program Heap separated from the RTEMS Workspace.
+ *
+ * @return Returns the heap control used for the C Program Heap.
+ */
+struct Heap_Control *_Workspace_Malloc_initialize_separate( void );
+
+/**
+ * @brief Initializes the C Program Heap so that it is unified with the RTEMS
+ * Workspace.
+ *
+ * @return Returns the heap control used for the C Program Heap.
+ */
+struct Heap_Control *_Workspace_Malloc_initialize_unified( void );
+
+/**
+ * @brief This constant provides the C Program Heap initialization handler.
+ *
+ * This constant is defined by the application configuration option
+ * #CONFIGURE_UNIFIED_WORK_AREAS via <rtems/confdefs.h> or a default
+ * configuration.
+ */
+extern struct Heap_Control *( * const _Workspace_Malloc_initializer )( void );
+
 /** @} */
 
Index: cpukit/libcsupport/src/malloc_initialize.c
===================================================================
--- cpukit/libcsupport/src/malloc_initialize.c	(revision 71689a0775f39d65b3c9f0a81b58394d0b04e534)
+++ cpukit/libcsupport/src/malloc_initialize.c	(revision f2185d109930fb5db31a5c228a3f46178072f270)
@@ -20,67 +20,51 @@
 #include <rtems/malloc.h>
 #include <rtems/score/wkspace.h>
-#include <rtems/sysinit.h>
 
 #include "malloc_p.h"
-
-Heap_Control *RTEMS_Malloc_Heap;
-
-static void _Malloc_Initialize( void )
-{
-  RTEMS_Malloc_Initialize( _Memory_Get(), _Heap_Extend );
-}
-
-RTEMS_SYSINIT_ITEM(
-  _Malloc_Initialize,
-  RTEMS_SYSINIT_MALLOC,
-  RTEMS_SYSINIT_ORDER_MIDDLE
-);
 
 #ifdef RTEMS_NEWLIB
 static Heap_Control _Malloc_Heap;
 
-void RTEMS_Malloc_Initialize(
+Heap_Control *RTEMS_Malloc_Initialize(
   const Memory_Information              *mem,
   Heap_Initialization_or_extend_handler  extend
 )
 {
-  if ( rtems_configuration_get_unified_work_area() ) {
-    RTEMS_Malloc_Heap = &_Workspace_Area;
-  } else {
-    Heap_Control                          *heap;
-    Heap_Initialization_or_extend_handler  init_or_extend;
-    uintptr_t                              page_size;
-    size_t                                 i;
+  Heap_Control                          *heap;
+  Heap_Initialization_or_extend_handler  init_or_extend;
+  uintptr_t                              page_size;
+  size_t                                 i;
 
-    heap = &_Malloc_Heap;
-    RTEMS_Malloc_Heap = heap;
-    init_or_extend = _Heap_Initialize;
-    page_size = CPU_HEAP_ALIGNMENT;
+  heap = &_Malloc_Heap;
+  RTEMS_Malloc_Heap = heap;
+  init_or_extend = _Heap_Initialize;
+  page_size = CPU_HEAP_ALIGNMENT;
 
-    for (i = 0; i < _Memory_Get_count( mem ); ++i) {
-      Memory_Area *area;
-      uintptr_t    space_available;
+  for (i = 0; i < _Memory_Get_count( mem ); ++i) {
+    Memory_Area *area;
+    uintptr_t    space_available;
 
-      area = _Memory_Get_area( mem, i );
-      space_available = ( *init_or_extend )(
-        heap,
-        _Memory_Get_free_begin( area ),
-        _Memory_Get_free_size( area ),
-        page_size
-      );
+    area = _Memory_Get_area( mem, i );
+    space_available = ( *init_or_extend )(
+      heap,
+      _Memory_Get_free_begin( area ),
+      _Memory_Get_free_size( area ),
+      page_size
+    );
 
-      if ( space_available > 0 ) {
-        _Memory_Consume( area, _Memory_Get_free_size( area ) );
-        init_or_extend = extend;
-      }
-    }
-
-    if ( init_or_extend == _Heap_Initialize ) {
-      _Internal_error( INTERNAL_ERROR_NO_MEMORY_FOR_HEAP );
+    if ( space_available > 0 ) {
+      _Memory_Consume( area, _Memory_Get_free_size( area ) );
+      init_or_extend = extend;
     }
   }
+
+  if ( init_or_extend == _Heap_Initialize ) {
+    _Internal_error( INTERNAL_ERROR_NO_MEMORY_FOR_HEAP );
+  }
+
+  return heap;
 }
 #else
-void RTEMS_Malloc_Initialize(
+Heap_Control *RTEMS_Malloc_Initialize(
   const Memory_Information              *mem,
   Heap_Initialization_or_extend_handler  extend
@@ -88,4 +72,10 @@
 {
   /* FIXME: Dummy function */
+  return NULL;
 }
 #endif
+
+Heap_Control *_Workspace_Malloc_initialize_separate( void )
+{
+  return RTEMS_Malloc_Initialize( _Memory_Get(), _Heap_Extend );
+}
Index: cpukit/libcsupport/src/mallocheap.c
===================================================================
--- cpukit/libcsupport/src/mallocheap.c	(revision f2185d109930fb5db31a5c228a3f46178072f270)
+++ cpukit/libcsupport/src/mallocheap.c	(revision f2185d109930fb5db31a5c228a3f46178072f270)
@@ -0,0 +1,56 @@
+/* SPDX-License-Identifier: BSD-2-Clause */
+
+/**
+ * @file
+ *
+ * @ingroup MallocSupport
+ *
+ * @brief This source file provides the C Program Heap control along with the
+ *   system initialization handler.
+ */
+
+/*
+ * Copyright (C) 2020 embedded brains GmbH (http://www.embedded-brains.de)
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <rtems/malloc.h>
+#include <rtems/sysinit.h>
+#include <rtems/score/wkspacedata.h>
+
+Heap_Control *RTEMS_Malloc_Heap;
+
+static void _Malloc_Initialize( void )
+{
+  RTEMS_Malloc_Heap = ( *_Workspace_Malloc_initializer )();
+}
+
+RTEMS_SYSINIT_ITEM(
+  _Malloc_Initialize,
+  RTEMS_SYSINIT_MALLOC,
+  RTEMS_SYSINIT_ORDER_MIDDLE
+);
Index: cpukit/score/src/wkspacemallocinitdefault.c
===================================================================
--- cpukit/score/src/wkspacemallocinitdefault.c	(revision f2185d109930fb5db31a5c228a3f46178072f270)
+++ cpukit/score/src/wkspacemallocinitdefault.c	(revision f2185d109930fb5db31a5c228a3f46178072f270)
@@ -0,0 +1,44 @@
+/* SPDX-License-Identifier: BSD-2-Clause */
+
+/**
+ * @file
+ *
+ * @ingroup RTEMSScoreWorkspace
+ *
+ * @brief This source file provides the default definition of
+ * _Workspace_Malloc_initializer.
+ */
+
+/*
+ * Copyright (C) 2020 embedded brains GmbH (http://www.embedded-brains.de)
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <rtems/score/wkspacedata.h>
+
+struct Heap_Control *( * const _Workspace_Malloc_initializer )( void ) =
+  _Workspace_Malloc_initialize_separate;
Index: cpukit/score/src/wkspacemallocinitunified.c
===================================================================
--- cpukit/score/src/wkspacemallocinitunified.c	(revision f2185d109930fb5db31a5c228a3f46178072f270)
+++ cpukit/score/src/wkspacemallocinitunified.c	(revision f2185d109930fb5db31a5c228a3f46178072f270)
@@ -0,0 +1,47 @@
+/* SPDX-License-Identifier: BSD-2-Clause */
+
+/**
+ * @file
+ *
+ * @ingroup RTEMSScoreWorkspace
+ *
+ * @brief This source file provides the implementation of
+ *   _Workspace_Malloc_initialize_unified().
+ */
+
+/*
+ * Copyright (C) 2020 embedded brains GmbH (http://www.embedded-brains.de)
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <rtems/score/wkspacedata.h>
+#include <rtems/score/wkspace.h>
+
+Heap_Control *_Workspace_Malloc_initialize_unified( void )
+{
+  return &_Workspace_Area;
+}
Index: spec/build/cpukit/librtemscpu.yml
===================================================================
--- spec/build/cpukit/librtemscpu.yml	(revision 71689a0775f39d65b3c9f0a81b58394d0b04e534)
+++ spec/build/cpukit/librtemscpu.yml	(revision f2185d109930fb5db31a5c228a3f46178072f270)
@@ -670,4 +670,5 @@
 - cpukit/libcsupport/src/mallocfreespace.c
 - cpukit/libcsupport/src/mallocgetheapptr.c
+- cpukit/libcsupport/src/mallocheap.c
 - cpukit/libcsupport/src/mallocinfo.c
 - cpukit/libcsupport/src/malloc_initialize.c
@@ -1576,4 +1577,6 @@
 - cpukit/score/src/wkspace.c
 - cpukit/score/src/wkspaceisunifieddefault.c
+- cpukit/score/src/wkspacemallocinitdefault.c
+- cpukit/score/src/wkspacemallocinitunified.c
 - cpukit/score/src/wkstringduplicate.c
 target: rtemscpu
